From df2130ce09ccb8d53e46f7b4dfd49b67089c66f5 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 733/1001] Replace the chrome wrapper with template inheritance


---

diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index d068a1b..6fa31e9 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -19,5 +19,7 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         self.assertDictEqual(data['data'], {
             u'edit_url': u'/ralph/56/edit',
             u'source_url': u'/source/about',
-            u'text': u'Testing.',
+            'text': 'Testing.',
+            'title': "<span class='glyphicon glyphicon-info-sign' "
+                     "aria-hidden='true'></span> About",
         })
diff --git a/hubs/tests/test_widgets/test_library.py b/hubs/tests/test_widgets/test_library.py
index 92b4bde..6e4ba36 100644
--- a/hubs/tests/test_widgets/test_library.py
+++ b/hubs/tests/test_widgets/test_library.py
@@ -18,6 +18,7 @@ class TestLibrary(hubs.tests.test_widgets.WidgetTest):
                 "urls": "ralph/"
             },
             "data": {
+                'title': 'Library',
                 "edit_url": "/ralph/%d/edit" % widget.idx,
                 "source_url": "/source/library",
                 "urls": [
diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index aff28b0..aa8ff61 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -1,6 +1,5 @@
 from __future__ import unicode_literals
 
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 from hubs import validators
@@ -24,7 +23,10 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/about.html"
-    chrome = panel("<span class='glyphicon glyphicon-info-sign' aria-hidden='true'></span> About")
 
     def get_context(self, instance, *args, **kwargs):
-        return dict(text=instance.config["text"])
+        return dict(
+            text=instance.config["text"],
+            title="<span class='glyphicon glyphicon-info-sign' "
+                  "aria-hidden='true'></span> About",
+            )
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index a6d838f..3664ae5 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -6,7 +6,6 @@ import requests
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 class Badges(Widget):
@@ -27,11 +26,12 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/badges.html"
-    chrome = panel("Badges")
 
     def get_context(self, instance, *args, **kwargs):
+        context = {"title": "Badges"}
         get_badges = GetBadges(instance)
-        return get_badges()
+        context.update(get_badges())
+        return context
 
 
 class GetBadges(CachedFunction):
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index ca42357..6a27bec 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -6,7 +6,6 @@ import pkgwat.api
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 PKGDB_URL = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
@@ -30,11 +29,11 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/bugzilla.html"
-    chrome = panel("Bugzilla: Issues")
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
         return dict(
+            title="Bugzilla: Issues",
             username=instance.config["username"],
             issues=get_issues()
             )
diff --git a/hubs/widgets/contact/__init__.py b/hubs/widgets/contact/__init__.py
index 88841fe..c491eb3 100644
--- a/hubs/widgets/contact/__init__.py
+++ b/hubs/widgets/contact/__init__.py
@@ -7,7 +7,6 @@ import fedmsg.meta
 import hubs.models
 
 from hubs.widgets.base import Widget, WidgetView
-from hubs.widgets.chrome import panel
 
 config = fedmsg.config.load_config()
 
@@ -23,7 +22,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/contact.html"
-    chrome = panel()
 
     def get_context(self, instance, *args, **kwargs):
         ''' Data for Contact widget. Checks if the hub associated
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index 738711a..1a96ee5 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -1,7 +1,6 @@
 from __future__ import unicode_literals
 
 from hubs import validators
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -23,7 +22,9 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/dummy.html"
-    chrome = panel("This is a dummy widget")
 
     def get_context(self, instance, *args, **kwargs):
-        return dict(text=instance.config["text"])
+        return dict(
+            title="This is a dummy widget",
+            text=instance.config["text"],
+            )
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index b31ae11..82f68c1 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -9,7 +9,6 @@ from hubs import validators
 from hubs.utils import commas
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 fedmsg_config = fedmsg.config.load_config()
 
@@ -32,7 +31,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/fedmsgstats.html"
-    chrome = panel()
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index 678152d..d2601f1 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -2,7 +2,6 @@ from __future__ import unicode_literals
 
 
 from hubs import validators
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 import logging
@@ -34,7 +33,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/feed.html"
-    chrome = panel("Live Feed")
 
     def get_context(self, instance, *args, **kwargs):
         # Avoid circular import
@@ -42,6 +40,7 @@ class BaseView(WidgetView):
         username = instance.config["username"]
         feed_url = app.config['SSE_URL'] + username
         return dict(
+            title="Live Feed",
             matches=[],
             message_limit=instance.config["message_limit"],
             feed_url=feed_url,
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index ec1dc93..3c55f9c 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -5,7 +5,6 @@ from six.moves.xmlrpc_client import ServerProxy
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 class FedoraHosted(Widget):
@@ -33,11 +32,13 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/fedorahosted.html"
-    chrome = panel("Fedorahosted: Open Tickets")
 
     def get_context(self, instance, *args, **kwargs):
         get_tickets = GetTickets(instance)
-        context = dict(project=instance.config["project"])
+        context = dict(
+            title="Fedorahosted: Open Tickets",
+            project=instance.config["project"],
+            )
         context.update(get_tickets())
         return context
 
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 5478f1c..9a03bc5 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -6,7 +6,6 @@ import hubs.utils
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 import fedmsg.config
 fedmsg_config = fedmsg.config.load_config()
@@ -39,7 +38,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/github_pr.html"
-    chrome = panel("Github: Pull Requests")
 
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
@@ -48,6 +46,7 @@ class BaseView(WidgetView):
         context = dict(
             organization=org,
             display_number=display_number,
+            title="Github: Pull Requests",
         )
         context.update(get_prs())
         return context
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index efee564..e70dabf 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -5,7 +5,6 @@ import requests
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 class GitHubIssues(Widget):
@@ -39,7 +38,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/githubissues.html"
-    chrome = panel("Github: Newest Open Tickets")
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
@@ -47,6 +45,7 @@ class BaseView(WidgetView):
             org=instance.config["org"],
             repo=instance.config["repo"],
             display_number=int(instance.config["display_number"]),
+            title="Github: Newest Open Tickets",
             all_issues=get_issues(),
         )
 
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index 09ec390..af990ac 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -2,7 +2,6 @@ from __future__ import unicode_literals
 
 from hubs import validators
 from hubs.widgets import clean_input
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -26,7 +25,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/library.html"
-    chrome = panel("Library")
 
     def get_context(self, instance, *args, **kwargs):
         urls = [
@@ -35,4 +33,7 @@ class BaseView(WidgetView):
             for u in instance.config.get('urls', '').split(',')
             if u.strip()
         ]
-        return dict(urls=urls)
+        return dict(
+            title="Library",
+            urls=urls,
+            )
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index c7ac68e..adc9590 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -1,7 +1,6 @@
 from __future__ import unicode_literals
 
 from hubs import validators
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -23,7 +22,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/linechart.html"
-    chrome = panel("Weekly Activity")
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
@@ -42,4 +40,7 @@ class BaseView(WidgetView):
                "&user={username}&split_on=categories")
         url = url + "&" + categories
         url = url.format(username=username)
-        return dict(url=url)
+        return dict(
+            title="Weekly Activity",
+            url=url,
+            )
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index 9209de2..8a5c7ef 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -7,7 +7,6 @@ import requests
 
 from hubs import validators
 from hubs import utils
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
@@ -43,11 +42,11 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/meetings.html"
-    chrome = panel(title='Meetings', footer_template='templates/meeting_footer.html')
 
     def get_context(self, instance, *args, **kwargs):
         get_meetings = GetMeetings(instance)
         return dict(
+            title="Meetings",
             calendar=instance.config["calendar"],
             meetings=get_meetings(),
             )
diff --git a/hubs/widgets/memberships/__init__.py b/hubs/widgets/memberships/__init__.py
index cc8f602..cd36983 100644
--- a/hubs/widgets/memberships/__init__.py
+++ b/hubs/widgets/memberships/__init__.py
@@ -2,7 +2,6 @@ from __future__ import unicode_literals
 
 import hubs.models
 
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -20,7 +19,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/memberships.html"
-    chrome = panel('Hubs')
 
     def get_context(self, instance, *args, **kwargs):
         hub = instance.hub
@@ -40,6 +38,7 @@ class BaseView(WidgetView):
         oldest_members = sorted(
             members, key=lambda m: m.get('created_on'))[:ELLIPSIS_LIMIT]
         return dict(
+            title="Hubs",
             memberships=list(members),
             oldest_members=list(oldest_members),
             )
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 6e3cf5a..ad047a7 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -3,7 +3,6 @@ from __future__ import unicode_literals
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 import requests
 
@@ -29,11 +28,13 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/pagure_pr.html"
-    chrome = panel("Newest Open Pull Requests on Pagure")
 
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
-        context = dict(repo=instance.config["repo"])
+        context = dict(
+            title="Newest Open Pull Requests on Pagure",
+            repo=instance.config["repo"],
+            )
         context.update(get_prs())
         return context
 
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index 2be36a8..690dd86 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -5,7 +5,6 @@ import requests
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 pagure_url = "https://pagure.io/api/0"
 
@@ -29,11 +28,13 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/pagureissues.html"
-    chrome = panel("Newest Open Tickets on Pagure")
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
-        context = dict(repo=instance.config["repo"])
+        context = dict(
+            title="Newest Open Tickets on Pagure",
+            repo=instance.config["repo"],
+            )
         context.update(get_issues())
         return context
 
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index 742ff22..84b2016 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -4,7 +4,6 @@ from collections import OrderedDict as ordereddict
 
 from hubs import validators
 from hubs.utils import username2avatar
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -48,7 +47,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/rules.html"
-    chrome = panel()
 
     def get_context(self, instance, *args, **kwargs):
         owners = instance.hub.owners
diff --git a/hubs/widgets/stats/__init__.py b/hubs/widgets/stats/__init__.py
index 1ffe664..87d4415 100644
--- a/hubs/widgets/stats/__init__.py
+++ b/hubs/widgets/stats/__init__.py
@@ -5,7 +5,6 @@ import flask
 from hubs.utils import commas
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 class Stats(Widget):
@@ -19,7 +18,6 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/stats.html"
-    chrome = panel()
 
     def get_context(self, instance, *args, **kwargs):
         get_stats = GetStats(instance)
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 409b382..28c8fed 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -1,7 +1,6 @@
 from __future__ import unicode_literals
 
 from hubs import validators
-from hubs.widgets.chrome import panel
 from hubs.widgets.base import Widget, WidgetView
 
 
@@ -24,8 +23,11 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/sticky.html"
-    chrome = panel(title='Sticky Note', klass="card-info")
 
     def get_context(self, instance, *args, **kwargs):
         # TODO -- render with markdown
-        return dict(text=instance.config["text"])
+        return dict(
+            text=instance.config["text"],
+            title="Sticky Note",
+            panel_css_class="card-info",
+            )
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index 352945d..466beb9 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -6,7 +6,6 @@ import hubs.models
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 from fedmsg.meta.base import BaseConglomerator as BC
 
@@ -33,11 +32,12 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     template_name = "templates/subscriptions.html"
-    chrome = panel('Hubs', key='associations')
 
     def get_context(self, instance, *args, **kwargs):
+        context = dict(title="Hubs")
         get_subs = GetSubs(instance)
-        return get_subs()
+        context.update(get_subs())
+        return context
 
 
 # function hyperlinks the hubs in the subscription widget
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index f6f486a..3c2ccb7 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -1,6 +1,5 @@
 from __future__ import unicode_literals, absolute_import
 
-import flask
 from flask.views import View
 
 
@@ -33,7 +32,6 @@ class WidgetView(View):
             for (like the `rule` parameter of Flask's `add_url_rule()`).
         template_name (str): The template name to use for this view. It will be
             looked for in the widget's template environment.
-        chrome (function): An optional chrome template wrapper.
 
     This class is Flask-specific. If another framework were to be switched to,
     it would have to be re-implemented.
@@ -42,7 +40,6 @@ class WidgetView(View):
     name = None
     url_rules = []
     template_name = None
-    chrome = None
 
     def __init__(self, widget):
         """
@@ -104,8 +101,4 @@ class WidgetView(View):
         instance = self._get_instance(*args, **kwargs)
         context = self.get_context(instance, *args, **kwargs)
         context.update(self.get_extra_context(instance, *args, **kwargs))
-        template = self.get_template()
-        if self.chrome is None:
-            return self.get_template().render(**context)
-        else:
-            return self.chrome(template.render)(**context)
+        return self.get_template().render(**context)
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 4676844..cc4cb3a 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -6,7 +6,6 @@ from hubs import validators
 from hubs.utils import username2avatar
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 class PendingACLs(Widget):
@@ -29,12 +28,13 @@ class BaseView(WidgetView):
     url_rules = ["/"]
     # TODO -- add approve/deny buttons or just link through to pkgdb
     template_name = "templates/workflow/pendingacls.html"
-    # If 'pending_acls' is empty, then don't render any chrome.
-    chrome = panel('Pending ACL Requests', key='pending_acls')
 
     def get_context(self, instance, *args, **kwargs):
         get_pending = GetPending(instance)
-        context = dict(username=instance.config["username"])
+        context = dict(
+            title='Pending ACL Requests',
+            username=instance.config["username"],
+            )
         context.update(get_pending())
         return context
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 7bca860..00df8fc 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -5,7 +5,6 @@ import requests
 from hubs import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
-from hubs.widgets.chrome import panel
 
 
 # TODO - the bodhi api exposes a new flag we can use instead of scraping
@@ -33,12 +32,13 @@ class BaseView(WidgetView):
     url_rules = ["/"]
     # TODO -- add approve/deny buttons or just link through to pkgdb
     template_name = "templates/workflow/updates2stable.html"
-    # If 'updates' is empty, then don't render any chrome.
-    chrome = panel('Updates Ready for Stable', key='updates')
 
     def get_context(self, instance, *args, **kwargs):
         get_pending = GetPending(instance)
-        context = dict(username=instance.config["username"])
+        context = dict(
+            title='Updates Ready for Stable',
+            username=instance.config["username"],
+            )
         context.update(get_pending())
         return context
 

